class Libro
{
    protected int numPagine;

    public Libro(int num)
    {
	numPagine = num;
    }

    public void pageMessage()
    {
	System.out.println("Numero di pagine: " + numPagine);
    }
}

class Vocabolario extends Libro
{ 
    protected int numDefinizioni;

    public Vocabolario(int numP, int numD)
    {
	super(numP);
	numDefinizioni = numD;
    }

    public void definitionMessage()
    {
	super.pageMessage();
	System.out.println("Numero di definizioni: " + numDefinizioni);
	System.out.println("Numero medio di definizioni per pagina: " + numDefinizioni/numPagine);
    }
}

public class TestLibroVocabolario
{
    public static void main(String[] args)
    {
	Libro b;
	
	b = new Libro(1500);
	System.out.println("*********\n* LIBRO *\n*********");
	b.pageMessage();
	
	b = new Vocabolario(1500,52500);
	System.out.println("***************\n* VOCABOLARIO *\n***************");
	// il comando:
	// b.definitionMessage();
	// darebbe un errore in compilazione: 
	// b e' una variabile di tipo Libro, ma definitionMessage() 
	// un metodo della sottoclasse Vocabolario.
	// dato che il "tipo effettivo" di b e' Vocabolario, possiamo fare
	// un cast:

	((Vocabolario) b).definitionMessage();
    }
}



