import lab2.*;

class Entry
{
  String nome, numTel;
  Entry(String nome, String tel)
  {
    this.nome = nome; 
    this.numTel = tel;
  }
  Entry(String nome)
  {
    this.nome = nome; 
  }
  String getTel() 
  { 
    return numTel;
  }
  String getNome()
  {
    return nome;
  }
  public boolean equals(Object obj) 
  {
    return ((obj instanceof Entry) && this.getNome().equalsIgnoreCase(((Entry) obj).getNome()));
  }

  public int hashCode()
  {
    return this.nome.hashCode();
  }
}

public class Rubrica
{   
  public static void main(String[] args)
  {
    ConsoleReader console = new ConsoleReader(System.in);
    RetSet rubrica = new HashRetSet();
    String nome, numTel;
    for (int i = 1; i <= 3; i++)
      {
	System.out.print("Nome: ");
	nome = console.readLine();
	System.out.print("NumTel: ");
	numTel = console.readLine();
	rubrica.add(new Entry(nome, numTel));
      }
    boolean ricerca= true;
    while(ricerca)
      {
	System.out.print("Nome da cercare nella rubrica: ");
	nome = console.readLine();
	Entry entry = (Entry) (rubrica.retrieve(new Entry(nome)));
	if (entry == null) System.out.println("Non trovato");
	else System.out.println("Il numero di " + nome + " e' " + entry.getTel());
	System.out.println("Vuoi cercare ancora [s/n]?");
	String risposta = console.readLine();
	if(risposta.equalsIgnoreCase("n")) ricerca = false;
      }
   }    
}







