import lab2.*;

public class SetTheory
{
  public static Set union (Set s1, Set s2)
  {
    Set unione = new HashSet();
    Iterator its1 = s1.iterator();
    while(its1.hasNext())
      unione.add(its1.next());
    Iterator its2 = s2.iterator();
    while(its2.hasNext())
      unione.add(its2.next());
    return unione;
  }
  
  public static Set intersection (Set s1, Set s2)
  {
    Set intersezione = new HashSet();
    Iterator its1 = s1.iterator();
    while(its1.hasNext())
      {
	Object elemento = its1.next();
	if(s2.contains(elemento))
	  intersezione.add(elemento);
      }
    return intersezione;
  }

  public static Set difference (Set s1, Set s2) 
  {
    Set differenza = new HashSet();
    Iterator its1 = s1.iterator();
    while(its1.hasNext())
      {
	Object elemento = its1.next();
	if(!s2.contains(elemento))
	  differenza.add(elemento);
      }
    return differenza;
  }

  public static void main(String[] args)
  {
    Set s1 = creaRandomSet();
    Set s2 = creaRandomSet();
    System.out.print("s1 = ");
    printSet(s1);
    System.out.print("s2 = ");
    printSet(s2);
    System.out.print("unione(s1,s2) = ");
    printSet(union(s1,s2));
    System.out.print("intersezione(s1,s2) = ");
    printSet(intersection(s1,s2));
    System.out.print("differenza(s1,s2) = ");
    printSet(difference(s1,s2));
  }

  public static Set creaRandomSet()
  {
    Set s = new HashSet();
    for (int i = 1; i <= 10 ; i++)
      s.add(new Integer((int) (Math.random() * 5)));
    return s;
  }
  
  public static void printSet( Set theSet ) {
    System.out.print("{");
    Iterator itr = theSet.iterator( );
    while ( itr.hasNext( ) )
      System.out.print(" " + itr.next( ));
    System.out.println(" }");
  } 
}

    


 
