import lab2.*;

public class SortedUnion {
    public static List merge ( Queue q, Stack s) {
	// da completare
	if ((q == null) || (s == null)) 
	   throw new IllegalArgumentException("SortedUnion:merge");
	Queue qtmp = new ArrayQueue(); // coda ausiliaria
	Stack stmp = new ListStack(); // pila ausiliaria
	Set atmp = new TreeSet(); // Albero Binario di Ricerca ausiliario
	// copia il contenuto della coda q nell'insieme e nella
	// coda ausiliaria. Sfrutta il fatto che 'enqueue' restituisce
	// l'elemento inserito
	while (!q.isEmpty()){ 
	    atmp.add(qtmp.enqueue(q.dequeue()));
	}
	// ripristina lo stato iniziale della coda q
	while (!qtmp.isEmpty()){
	    q.enqueue(qtmp.dequeue());
	}
	// copia il contenuto della pila s nell'insieme e nella
	// pila ausiliaria. Sfrutta il fatto che 'push' restituisce
	// l'elemento inserito
	while (!s.isEmpty()){
	    atmp.add(stmp.push(s.pop()));
	}
	// ripristina lo stato iniziale della pila s
	while (!stmp.isEmpty()){
	   s.push(stmp.pop());
	}
	List l = new LinkedList();
	// inserisce tutti gli elementi dell'insieme ausiliario
	// nella lista, nell'ordine in cui sono restituiti
	// dall'iteratore
	Iterator setIt = atmp.iterator();
	while (setIt.hasNext())
	    l.add(setIt.next());
	return l;
    }
}


