import lab2.*;

public class CheckABR
{  
    public static boolean isABR(BinNode n)
    {
	if (n == null) return true;
	else if (n.left == null && n.right == null) return true;
	else if (n.left == null)
	    return (((Comparable) n.right.key).compareTo((Comparable) n.key) > 0 && isABR(n.right));
	else if (n.right == null)
	    return (((Comparable) n.left.key).compareTo((Comparable)n.key) < 0 && isABR(n.left));
	else return (((Comparable) n.left.key).compareTo((Comparable) n.key) < 0 && ((Comparable) n.right.key).compareTo((Comparable) n.key) > 0 && isABR(n.left) && isABR(n.right));
    }
    
    public static void main (String [] args)
    {
	BinNode A,B,C,D;
	A = new BinNode (new Integer(10));
	B = new BinNode (new Integer(20));
	C = new BinNode (new Integer(30),A,B);
	D = new BinNode (new Integer(40),null,C);
	if (isABR(D))
	    System.out.println("Il primo albero creato e' un ABR");
	else System.out.println("Il primo albero creato non e' un ABR");
	A = new BinNode (new Integer(10));
	B = new BinNode (new Integer(20));
	C = new BinNode (new Integer(15),A,B);
	D = new BinNode (new Integer(4),null,C);
	if (isABR(D))
	    System.out.println("Il secondo albero creato e' un ABR");
	else System.out.println("Il secondo albero creato non e' un ABR");
    }
}


