import lab2.*;

public class Fibonacci {
    
    public static boolean verificaFibonacci ( BinNode r ) {

	if ((r==null)|| ((r.left == null)&& (r.right== null)))
	    return true;
	return (Math.abs(depth(r.left)-depth(r.right)) == 1)
	    && verificaFibonacci(r.right) 
	    && verificaFibonacci(r.left);
    }

    public static int depth(BinNode r){
	if (r == null) return 0;
	return Math.max(depth(r.left),depth(r.right)) + 1;}
    
    public static void main (String [] args){
	BinNode A,B,C,D,E,F,G;
	A = new BinNode (new Integer(5));
	B = new BinNode (new Integer(7));
	C = new BinNode (new Integer(10),A,B);
	D = new BinNode (new Integer(30));
	E = new BinNode (new Integer(50));
	F = new BinNode (new Integer(40),D,E);
	G = new BinNode (new Integer(20),C,F);
	System.out.println("Albero originale:");
	System.out.println(print(G));
	if (verificaFibonacci(G))
	    System.out.println("E' un albero di Fibonacci");
	else 
	    System.out.println("Non e' un albero di Fibonacci");
	A = new BinNode (new Integer(5));
	B = new BinNode (new Integer(10),A,null);
	C = new BinNode (new Integer(40));
	D = new BinNode (new Integer(20),B,C);
	System.out.println("Albero originale:");
	System.out.println(print(D));
	if (verificaFibonacci(D))
	    System.out.println("E' un albero di Fibonacci");
	else 
	    System.out.println("Non e' un albero di Fibonacci");
    }
 
    public static String print (BinNode r){
	if (r == null) {
	    return "";
	}
	else
	    return ((r.left!=null)? "["+print(r.left)+"] ":"") +
		r.key + ((r.right != null)? " {" +print(r.right)+ 
			 "}":"");
    }
}

