import lab2.*;
public class Transpose{

    public static BinNode transpose (BinNode r){
	if (r == null) return null;
	BinNode left = transpose(r.right);
	BinNode right = transpose(r.left);
	return new BinNode(r.key,left,right);
    }

    public static void main (String [] args){
	BinNode A,B,C,D,E,F,G;
	A = new BinNode (new Integer(5));
	B = new BinNode (new Integer(7));
	C = new BinNode (new Integer(10),A,B);
	D = new BinNode (new Integer(30));
	E = new BinNode (new Integer(50));
	F = new BinNode (new Integer(40),D,E);
	G = new BinNode (new Integer(20),C,F);
	System.out.println("Albero originale:");
	System.out.println(print(G));
	System.out.println("Albero trasposto:");
	System.out.println(print(transpose(G)));	
	System.out.println("Di nuovo albero originale:");	
	System.out.println(print(G));
    }

    public static String print (BinNode r){
	if (r == null) {
	    return "";
	}
	else
	    return ((r.left!=null)? "["+print(r.left)+"] ":"") +
		r.key + ((r.right != null)? " {" +print(r.right)+ 
			 "}":"");
    }
}
