import lab2.*;

public class OrdinaListInv 
{ 
  public static List ordina ( List lst ) 
  {  
    if (lst == null || lst.isEmpty())
      throw new IllegalArgumentException();
    List tmp = new LinkedList();
    List ordinata = new LinkedList();
    Iterator itr1 = lst.iterator();
    while(itr1.hasNext())
      tmp.add(itr1.next());
    while(!tmp.isEmpty())
      {
	Iterator itr2 = tmp.iterator();
	Comparable max = (Comparable) itr2.next();
	while(itr2.hasNext())
	  {
	    Comparable estratto =  (Comparable) itr2.next();
	    if(estratto.compareTo(max) > 0) max = estratto;
	  }
	ordinata.add(max);
	while(tmp.contains(max)) tmp.remove(max);
      }
    return ordinata;
  }
  
  public static void main(String[] args)
  {
    List lista = new LinkedList();
    for(int i = 0; i < 10; i++)
      lista.add(new Integer((int) (Math.random() * 10)));
    System.out.print("Lista originale: ");
    printList(lista);
    List ordinata = ordina(lista);
    System.out.print("Lista ordinata: ");
    printList(ordinata);
  }
    
  public static void printList(List theList) 
  {  
    System.out.print( "[" ); 
    Iterator itr = theList.iterator( ); 
    while ( itr.hasNext( ) ) 
      System.out.print( "  " + itr.next( )); 
    System.out.println( " ]" ); 
  }
  
}












