import lab2.*;


public class TestAbsSet {

    public static Set creaTreeSet (int [] keys){
	Set s = new TreeSet();
	for (int i = 0; i < keys.length; i++)
	     s.add(new Integer(keys[i]));
	return s;
    }
    public static Set creaHashSet (int [] keys){
	Set s = new HashSet();
	for (int i = 0; i < keys.length; i++)
	     s.add(new Integer(keys[i]));
	return s;
    }
     public static String printSet( Set theSet ) {
	String s =  "{" ;
	Iterator itr = theSet.iterator( );
	while ( itr.hasNext( ) )
            s +=  "  " + itr.next( ) ;
	return s +  "}" ;
    }

    public static void main (String [] args){
	try{	
	System.out.println("Provo il metodo AbsSet.abs(Set)...");
	int [] arr = {7, 11, -45, -5, 0, 9, -10, 6, -1, 2};
	Set ls1 = creaTreeSet(arr);
	System.out.print("Somma di "+ printSet(ls1) + ":  ");
	int ls2 = AbsSet.abs(ls1);
	System.out.println(ls2);
	System.out.println("Insieme dopo abs:"+ printSet(ls1));

	int [] arr1 = { 11, 5, 9, 11, 6};
	arr = arr1;
	ls1 = creaHashSet(arr);
	System.out.print("Somma di "+ printSet(ls1) + ":  ");
	ls2 =  AbsSet.abs(ls1);
	System.out.println(ls2);
	System.out.println("Insieme dopo abs: "+ printSet(ls1));

	int [] arr2 = {};
	arr = arr2;
	ls1 = creaTreeSet(arr);
	System.out.print("Insieme vuoto. Somma: ");
	ls2 =  AbsSet.abs(ls1);
	System.out.println(ls2);

	int [] arr3 = {3, 56, 89};
	arr = arr3;
	ls1 = creaHashSet(arr);
	ls1.add("bingo!");
	System.out.println("Invoco abs("+ printSet(ls1)+")");
	boolean ok= false;
	try{ls2 = AbsSet.abs(ls1);
	}catch(IllegalArgumentException e){	
	System.out.println("Ok: togliMultipli ha lanciato una IllegalArgumentException");
	ok = true;}
	catch(Exception e){
	    System.out.println("Ho rilevato l'eccezione "+ e +
			       "\nma l'esercizio chiedeva di lanciare una IllegalArgumentException. "+
			       "\nSei in grado di farlo?");
	    return;
	}
	if (!ok){
	    	System.out.println("Mi aspettavo un'eccezione: c'era una stringa nella lista...");
		return;
	}
	
	}catch(Exception e){
	    System.out.println("\n OOPS!!! Stavo invocando il metodo che hai scritto\n "+
			       " ma si e' verificata un'eccezione:");
	    e.printStackTrace();
	    
	}
 
    
    }
}


 
