package lab2.Exceptions;

/**
 * Classe eccezione per pila vuota.
 * @author A. Brogi      (<A HREF="mailto:brogi@di.unipi.it">brogi@di.unipi.it</A>)
 * @author A. Corradini  (<A HREF="mailto:andrea@di.unipi.it">andrea@di.unipi.it</A>)
 * @author F. Gadducci   (<A HREF="mailto:gadducci@di.unipi.it">gadducci@di.unipi.it</A>)
 * @author R. Grossi     (<A HREF="mailto:grossi@di.unipi.it">grossi@di.unipi.it</A>)
 * @author C. Montangero (<A HREF="mailto:monta@di.unipi.it">monta@di.unipi.it</A>)
 * @author F. Romani     (<A HREF="mailto:romani@di.unipi.it">romani@di.unipi.it</A>)
 * @author L. Semini     (<A HREF="mailto:semini@di.unipi.it">semini@di.unipi.it</A>)
 */
public class EmptyStackException extends RuntimeException {
    /**
     * Costruttore dell'eccezione senza messaggi.
     */
    public EmptyStackException( ) {
        super( );
    }

    /**
     * Costruttore dell'eccezione con messaggio visibile 
     * successivamente mediante il metodo <code>getMessage</code>.
     * @param msg il messaggio di errore.
     */
    public EmptyStackException( String msg ) {
        super( msg);
    }
}
