import lab2.*;


public class TestMultipliList {

    public static List creaList (int [] keys){
	List l = new LinkedList();
	for (int i = 0; i < keys.length; i++)
	     l.add(new Integer(keys[i]));
	return l;
    }    
     public static String printList( List theList ) {
	String s =  "[" ;
	Iterator itr = theList.iterator( );
	while ( itr.hasNext( ) )
            s +=  "  " + itr.next( ) ;
	return s +  "]" ;
    }

    public static void main (String [] args){
	try{	
	System.out.println("Provo il metodo MultipliList.multipli(List,int)...");
	int [] arr = {7, 11, 45, -5, 0, 9, 10, 6, 1, 2};
	List ls1 = creaList(arr);
	System.out.print("Multipli di 5 in "+ printList(ls1));
	List ls2 = MultipliList.multipli(ls1,5);
	System.out.println(": "+ printList(ls2));
	System.out.println("Lista dopo multipli: "+ printList(ls1));

	int [] arr1 = { 11, -5, 9, 11, 6};
	arr = arr1;
	ls1 = creaList(arr);
	System.out.print("Multipli di 10 in "+ printList(ls1));
	ls2 = MultipliList.multipli(ls1,10);
	System.out.println(": "+ printList(ls2));
	System.out.println("Lista dopo multipli: "+ printList(ls1));

	int [] arr2 = {};
	arr = arr2;
	ls1 = creaList(arr);
	System.out.print("Multipli di 3 in "+ printList(ls1));
	ls2 = MultipliList.multipli(ls1,3);
	System.out.println(": "+ printList(ls2));
	System.out.println("Lista dopo multipli: "+ printList(ls1));

	int [] arr3 = {3, 56, 89};
	arr = arr3;
	ls1 = creaList(arr);
	ls1.add("bingo!");
	System.out.println("invoco multipli(2,"+ printList(ls1)+")");
	boolean ok= false;
	try{ls2 = MultipliList.multipli(ls1,3);
	}catch(ClassCastException e){
	System.out.println("Ok: multipli ha lanciato l'eccezione "+ e);
	ok = true;}
	catch(Exception e)
	{
		System.out.println("Ho rilevato l'eccezione "+ e +
				   "\nma sarebbe piu' corretto lanciare una ClassCastException. "+
				   "\nSei in grado di farlo?");
	}
	if (!ok){
	    	System.out.println("Mi aspettavo un'eccezione: c'era una stringa nella lista...");
		return;
}

	System.out.println("E se invoco  multipli(0,...) ?");
	int [] arr4 = {3, 56, 89};
	arr = arr3;
	ls1 = creaList(arr);
	try  
	    {
		ls2 = MultipliList.multipli(ls1,0);
	    }
	catch (ArithmeticException e)
	    {
		System.out.println("Ho rilevato l'eccezione "+ e +
				   "\nma sarebbe piu' corretto lanciare una IllegalArgumentException. "+
				   "\nSei in grado di farlo?");
	    }
	catch (IllegalArgumentException e)
	    {
		System.out.println("Bene: mi aspettavo proprio una "+e);
	    }
		
	
	}
	catch(Exception e)
	    {
		System.out.println("\n OOPS!!! Stavo invocando il metodo che hai scritto\n "+
				   " ma si e' verificata un'eccezione:");
		e.printStackTrace();
		
	    }
    }
    
}



 
