import lab2.*;

public class OrdinaPila
{
  
  // ipotesi: la pila contiene istanze di Integer. 
    
  public static void ordinaPila(Stack pila) 
  {
    Stack tmp = new ArrayStack();
    Stack pilaOrd = new ArrayStack();

    while(!pila.isEmpty()) 
      {
	// cerco ed estraggo l'elemento massimo della pila
	Object o = pila.pop();
	int max = ((Integer) o).intValue();
	while(!pila.isEmpty()) 
	  {
	    o = pila.pop();
	    int val = ((Integer) o).intValue();
	    if(max < val) {
	      tmp.push(new Integer(max));
	      max = val;
	    }
	    else tmp.push(o);
	  }
	// inserisco l'elemento massimo trovato nella pila ordinata
	pilaOrd.push(new Integer(max));
	
	// inserisco nella pila da ordinare tutti gli elementi estratti,
	// tranne il massimo trovato, per poi proseguire iterativamente. 
	while (!tmp.isEmpty()) pila.push(tmp.pop());
	

      }
    while (!pilaOrd.isEmpty()) pila.push(pilaOrd.pop());
  }

  // programma di prova
  
  public static void main(String args[]) {
    Stack pila = new ArrayStack();
    for(int i=0; i<5;i++) 
      pila.push(new Integer((int) (Math.random() * 10)));
    StampaPila.print(pila);
    System.out.println("Ordino la pila... ");
    ordinaPila(pila); 
    StampaPila.print(pila);
  }
}

