import lab2.*;
import lab2.Exceptions.*;

public class ListaPari
{
    
    public static List rimuoviPari(List theList) 
    { 
	List listaPari = new LinkedList();
	Iterator itr = theList.iterator( ); 
	while ( itr.hasNext( ) ) { 
	    try {
		Integer estratto = (Integer) itr.next();
		if(estratto.intValue() % 2 == 0) {
		    itr.remove();
		    listaPari.add(estratto);
		}
	    }
	    catch (ClassCastException e) {
		  System.out.println("Trovato elemento che non e' un'istanza di Integer..."); 
	    } 
	} 
	return listaPari;
    }
    
    public static void main(String[] args)
    {
	

	List lista = new LinkedList();
	
	for(int i = 0; i < 10; i++)
	    lista.add(new Integer((int) (Math.random() * 10)));
	System.out.print("Lista originale: ");
	printList(lista);
	List pari = rimuoviPari(lista);
	System.out.print("Lista modificata: ");
	printList(lista);
	System.out.print("Lista con gli elementi pari: ");
	printList(pari);
    }
    
    public static void printList(List theList) 
    {  
	System.out.print( "[" ); 
	Iterator itr = theList.iterator( ); 
	while ( itr.hasNext( ) ) 
	    System.out.print( "  " + itr.next( )
			      ); 
	System.out.println( " ]" ); 
    }
    
}





