class Point{

    protected int x;
    protected int y;

    public Point() {
       x=0;
       y=0;
    }

    public Point(int _x, int _y){
        x=_x;
        y=_y;
    }
   public String toString(){

		return "x: "+ x + " y:" + y;
	}

   public int getx(){
      return x;
   }
   public void setx(int _x){
	      x=_x;
   }
   public int gety(){
   	 return y;
   }
   public void sety(int _y){
	      y=_y;
   }
   public void SpostaVert(int v){
		y=y+v;
	}

   public void SpostaOriz(int o){
			x=x+o;
	}

	public double Distanza(Point p){
		int x2 = ((x-p.x)*(x-p.x));
		int y2 = ((y-p.y)*(y-p.y));
		return Math.sqrt(x2+y2);
	}

	public double DistanzaOrigine(){
		Point p=new Point();
		return Distanza(p);
	}

  public boolean VicinoOrigine(Point p){
	 return (DistanzaOrigine()<p.DistanzaOrigine());

  }
  public boolean Uguale(Point p){
	  return (this.x==p.x && this.y==p.y);
  }
}


class OrientedPoint extends Point{

	private  char d;

	static char INITD='N';

	OrientedPoint(){
		d=INITD;
	}

	OrientedPoint(int _x, int _y,char _d){
		x=_x;
		y=_y;
		d=_d;
	}

	OrientedPoint(int _x, int _y){
			x=_x;
			y=_y;
			d=INITD;
	}
	public char getd(){
	      return d;
	   }
	   
   public void setd(char _d){
		      d=_d;
   }
	public String toString(){
			return "x: "+ x + " y:" + y + " direzione " + d;
	}

	public void Trasla(int trasla){

		switch(d){
			case 'N':
				x=x+trasla;
				return;
			case 'S':
				x=x-trasla;
				return;
			case 'E':
				y=y+trasla;
				return;
			case 'W':
				y=y-trasla;
				return;
		}
	}
	public void GiraPuntoSO(){
			switch(d){
			case 'N':
				d='E';
				return;
			case 'S':
				d='W';
				return;
			case 'E':
				d='S';
				return;
			case 'W':
				d='N';
				return;

		}
	}
	public void GiraDirezioneSO(){
				switch(d){
				case 'N':
					INITD='E';
					return;
				case 'S':
					INITD='W';
					return;
				case 'E':
					INITD='S';
					return;
				case 'W':
					INITD='N';
					return;
			}
	}
	
	public boolean Uguale(OrientedPoint p){
	  return (x==p.getx() && y==p.gety() && d==p.getd());
		  	}
}

public class UsePoints {
	public static void main (String args[]){

	ConsoleReader console = new ConsoleReader(System.in);
	Point P = new Point();
	OrientedPoint OP = new OrientedPoint(5,5,'S');
	OP.GiraPuntoSO();
	System.out.print(" Punto girato in senso orario " + OP+ "\n");
	OP.Trasla(25);
	System.out.print(" Punto traslato " + OP + "\n");

	System.out.print("Inserisci un numero > 0 per un punto generico, <=0 per un punto orientato a N ");
	int cond = console.readInt();
	if (cond > 0)
		P = new Point(10, 10);
	else 
		P = new OrientedPoint (10,10,'N');
	
	System.out.println("Primo punto:" + P);
	System.out.println("Secondo punto:" + OP);
	System.out.println("Sono uguali? " + P.Uguale(OP));
	System.out.println("Il primo e' piu' vicino all'origine? " + P.VicinoOrigine(OP));
	}

}