class Point{

    protected int x;
    protected int y;

    public Point() {
       x=0;
       y=0;
    }

    public Point(int _x, int _y){
        x=_x;
        y=_y;
    }
   public String toString(){

		return "x: "+ x + " y:" + y;
	}

   public int getx(){
      return x;
   }
   public void setx(int _x){
	      x=_x;
   }
   public int gety(){
   	 return y;
   }
   public void sety(int _y){
	      y=_y;
   }
   public void SpostaVert(int v){
		y=y+v;
	}

   public void SpostaOriz(int o){
			x=x+o;
	}

	public double Distanza(Point p){
		int x2 = ((x-p.x)*(x-p.x));
		int y2 = ((y-p.y)*(y-p.y));
		return Math.sqrt(x2+y2);
	}

	public double DistanzaOrigine(){
		Point p=new Point();
		return Distanza(p);
	}
	public boolean VicinoOrigine(Point p){
	 return (DistanzaOrigine()<p.DistanzaOrigine());

  }
  public boolean Uguale(Point p){
	  return (this.x==p.x && this.y==p.y);
  }
}


class Circle extends Point{

int raggio;

public Circle ()
{
super();
raggio=1;
}

public Circle (int a,int b, int c)
{
super (a,b);
raggio=c;
}

public Circle (int a,int b)
{
super (a,b);
raggio=1;
}


public String toString()
{
	return ("coordinate ("+x+","+y+") raggio="+raggio);
}

public void scala(double s)
{
	raggio*=s;
}

public boolean Uguale (Circle a)
{
	return (super.Uguale(a) && raggio==a.raggio);
}

public double area()
	{	double area = Math.PI*Math.pow(raggio, 2);
		return area;
	}
	
	public double perimetro()
	{	double perimetro = 2*Math.PI*raggio;
		return perimetro;
	}
	
	public double DistanzaOrigine()
	{	double distance;
		distance = super.DistanzaOrigine();
		distance = Math.abs(distance-raggio);
		return distance;
	}
}

public class UsePoints {
	public static void main (String args[]){

	ConsoleReader console = new ConsoleReader(System.in);
	Point P = new Point();
	Circle C = new Circle(10,10,30);
	
	System.out.print("Inserisci un numero > 0 per un punto generico, <=0 per un cerchio");
	int cond = console.readInt();
	if (cond > 0)
		P = new Point(10, 10);
	else 
		P = new Circle (10,10,20);
		
	P.SpostaVert(10);
	C.SpostaVert(10);
	C.scala(0.5);
	System.out.println("Primo punto:" + P);
	System.out.println("Secondo punto:" + C);
	System.out.println("Sono uguali? " + P.Uguale(C));
	System.out.println("Il primo e' piu' vicino all'origine? " + P.VicinoOrigine(C));
	
	}

}